=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class GroupsUsersApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an user
    # Add a user to a group.
    # @param auth_group_href [String] 
    # @param group_user [GroupUser] 
    # @param [Hash] opts the optional parameters
    # @return [GroupUserResponse]
    def create(auth_group_href, group_user, opts = {})
      data, _status_code, _headers = create_with_http_info(auth_group_href, group_user, opts)
      data
    end

    # Create an user
    # Add a user to a group.
    # @param auth_group_href [String] 
    # @param group_user [GroupUser] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(GroupUserResponse, Integer, Hash)>] GroupUserResponse data, response status code and response headers
    def create_with_http_info(auth_group_href, group_user, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsUsersApi.create ...'
      end
      # verify the required parameter 'auth_group_href' is set
      if @api_client.config.client_side_validation && auth_group_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_group_href' when calling GroupsUsersApi.create"
      end
      # verify the required parameter 'group_user' is set
      if @api_client.config.client_side_validation && group_user.nil?
        fail ArgumentError, "Missing the required parameter 'group_user' when calling GroupsUsersApi.create"
      end
      # resource path
      local_var_path = '{auth_group_href}users/'.sub('{' + 'auth_group_href' + '}', CGI.escape(auth_group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(group_user) 

      # return_type
      return_type = opts[:return_type] || 'GroupUserResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsUsersApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an user
    # Remove a user from a group.
    # @param auth_groups_user_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete(auth_groups_user_href, opts = {})
      delete_with_http_info(auth_groups_user_href, opts)
      nil
    end

    # Delete an user
    # Remove a user from a group.
    # @param auth_groups_user_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Integer, Hash)>] nil, response status code and response headers
    def delete_with_http_info(auth_groups_user_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsUsersApi.delete ...'
      end
      # verify the required parameter 'auth_groups_user_href' is set
      if @api_client.config.client_side_validation && auth_groups_user_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_groups_user_href' when calling GroupsUsersApi.delete"
      end
      # resource path
      local_var_path = '{auth_groups_user_href}'.sub('{' + 'auth_groups_user_href' + '}', CGI.escape(auth_groups_user_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsUsersApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List users
    # List group users.
    # @param auth_group_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedGroupUserResponseList]
    def list(auth_group_href, opts = {})
      data, _status_code, _headers = list_with_http_info(auth_group_href, opts)
      data
    end

    # List users
    # List group users.
    # @param auth_group_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedGroupUserResponseList, Integer, Hash)>] PaginatedGroupUserResponseList data, response status code and response headers
    def list_with_http_info(auth_group_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: GroupsUsersApi.list ...'
      end
      # verify the required parameter 'auth_group_href' is set
      if @api_client.config.client_side_validation && auth_group_href.nil?
        fail ArgumentError, "Missing the required parameter 'auth_group_href' when calling GroupsUsersApi.list"
      end
      # resource path
      local_var_path = '{auth_group_href}users/'.sub('{' + 'auth_group_href' + '}', CGI.escape(auth_group_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedGroupUserResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: GroupsUsersApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
