=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpcoreClient
  class ImportersPulpImportCheckApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Validate the parameters to be used for a PulpImport call
    # Evaluates validity of proposed PulpImport parameters 'toc', 'path', and 'repo_mapping'.  * Checks that toc, path are in ALLOWED_IMPORT_PATHS * if ALLOWED:   * Checks that toc, path exist and are readable   * If toc specified, checks that containing dir is writeable * Checks that repo_mapping is valid JSON
    # @param pulp_import_check [PulpImportCheck] 
    # @param [Hash] opts the optional parameters
    # @return [PulpImportCheckResponse]
    def pulp_import_check_post(pulp_import_check, opts = {})
      data, _status_code, _headers = pulp_import_check_post_with_http_info(pulp_import_check, opts)
      data
    end

    # Validate the parameters to be used for a PulpImport call
    # Evaluates validity of proposed PulpImport parameters &#39;toc&#39;, &#39;path&#39;, and &#39;repo_mapping&#39;.  * Checks that toc, path are in ALLOWED_IMPORT_PATHS * if ALLOWED:   * Checks that toc, path exist and are readable   * If toc specified, checks that containing dir is writeable * Checks that repo_mapping is valid JSON
    # @param pulp_import_check [PulpImportCheck] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PulpImportCheckResponse, Integer, Hash)>] PulpImportCheckResponse data, response status code and response headers
    def pulp_import_check_post_with_http_info(pulp_import_check, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ImportersPulpImportCheckApi.pulp_import_check_post ...'
      end
      # verify the required parameter 'pulp_import_check' is set
      if @api_client.config.client_side_validation && pulp_import_check.nil?
        fail ArgumentError, "Missing the required parameter 'pulp_import_check' when calling ImportersPulpImportCheckApi.pulp_import_check_post"
      end
      # resource path
      local_var_path = '/pulp/api/v3/importers/core/pulp/import-check/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(pulp_import_check) 

      # return_type
      return_type = opts[:return_type] || 'PulpImportCheckResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ImportersPulpImportCheckApi#pulp_import_check_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
